/*
 *	essai libfloatimg + libtthimage
 */

#include  <stdio.h>
#include  <stdlib.h>
#include  <stdint.h>
#include  <string.h>
#include  <unistd.h>
#include  <sys/time.h>
#include  <math.h>

#include  <floatimg.h>
#include  <tthimage.h>

#include  "operator.h"
#include  "picfx.h"

extern int	verbosity;

/* ------------------------------------------------------------------------ */
int faire_le_cadre(Image_Desc *img, int dx, int dy, int tck)
{
char			chaine[100];
Image_Rect		rect;
int			foo;

Image_cadre_std2(img, 70, 35, 10, dx, dy);

rect.x = dx-6;			rect.y = dy-6;
rect.w = img->width-(dx*2)+12;	rect.h = img->height-(dy*2)+12;

#if DEBUG_LEVEL
Image_dump_rect(&rect, __func__, 1);
#endif

foo = Image_draw_rect(img, &rect, 192, 118, 64);
if (foo) {
	fprintf(stderr, "%s: draw rect --> %d\n", __func__, foo);
	return foo;
	}

sprintf(chaine, "%4d   %6.2fs", tck, (double)tck/FRAMERATE);
add_some_text(img, chaine, 0);

return 0;
}
/* ------------------------------------------------------------------------ */
int operation_descr(FloatImg *p_fimg, Image_Desc *p_img, int op, int tick)
{
int			foo, bar;
int			x, y, lineidx;
int			r, g, b;
float			mima[6], fred;
char			chaine[100];

#define KF (250.20 / 2.0)

if (verbosity) fimg_describe(p_fimg, "source image");

/* trying to get the good dynamic scale */
fimg_equalize(p_fimg, 3.141592654);

if (verbosity)
	{
	fimg_get_minmax_rgb(p_fimg, mima);
	fimg_print_minmax(mima, (char *)__func__);
	}

for (y=0; y<p_fimg->height; y++) {

	lineidx = p_fimg->width * y;		/* unrolling offset calculus */

	for (x=0; x<p_fimg->width; x++) {
		fred = p_fimg->R[lineidx + x];
		r = (int)( KF + KF * cos(fred *  1.00) );
		g = (int)( KF + KF * cos(fred *  2.00) );
		b = (int)( KF + KF * cos(fred *  3.00) );

		p_img->Rpix[y][x] = r;
		p_img->Gpix[y][x] = g;
		p_img->Bpix[y][x] = b;
		}
	}

switch (op) {
	case 0:		color_brotch_0(p_img, 0);		break;
	case 1:		color_brotch_1(p_img, 0);		break;
	case 2:		ondulation_0(p_img, tick);		break;
	case 3:		filtrage_0(p_img, tick);		break;
	case 4:		fragmentation(p_img, tick);		break;
	case 5:		television_5(p_img, tick, 0);		break;
	case 6:		television_5(p_img, tick, 1);		break;
	case 7:		television_5(p_img, tick, 2);		break;
	case 8:		television_5(p_img, tick, 3);		break;
	case 9:		microscope_0(p_img, tick, 0);		break;
	default:	Image_mircol_2(p_img, NULL, 0);		break;
		
	}

faire_le_cadre(p_img, 18, 42, tick);

/*
 *	truc foireux a revoir
 *
sprintf(chaine, "op%02d", op);
for (bar=0; bar<strlen(chaine); bar++) {
	// x = 50 + (tick/4) + (bar*41);
	x = 444 + (bar*41);
	foo = Image_trace_big_char_0(p_img, x, 52, chaine[bar], 5, 8);
	if (foo) {
		// fprintf(stderr, "%s: trace_big_char_0 -> %d\n", __func__, foo);
		// exit(1);
		}
	}
**/

return 0;
}
/* ------------------------------------------------------------------------ */
static int ecriture_sourcename(Image_Desc *img, char *texte)
{
int			foo;
RGBA			paper, ink;

paper.r = paper.g = paper.b = 0;		paper.a = 0;
ink.r = ink.g = ink.b = 200;			ink.a = 255;

foo = Image_trace_chaine_1(img, texte, 16, 14, NULL, &paper, &ink);
if (foo) {
	fprintf(stderr, "%s: trace chaine -> %d\n", __func__, foo);
	return -1;
	}
return 0;
}
/* ------------------------------------------------------------------------ */
/*
 *	    + operation sur une paire de fichierimage +
 *
 */
int operation_fname (char *srcname, char *dstname, int op, int tick)
{
int			foo;
FloatImg		fimg;
Image_Desc		*imgdesc;

#if DEBUG_LEVEL
fprintf(stderr, ">>> %s ( '%s' '%s'  %d %d)\n", __func__, srcname, dstname, op, tick);
#endif

foo = fimg_create_from_dump(srcname, &fimg);
if (foo) {
	fprintf(stderr, "fimg from dump -> %d\n", foo);
	return -1;
	}
if (verbosity) fprintf(stderr, "source image is %dx%d\n", fimg.width, fimg.height);

imgdesc = Image_alloc(fimg.width, fimg.height, IMAGE_RGB);
if (NULL == imgdesc) {
	fprintf(stderr, "image alloc ?\n");
	return -1;
	}

/*	REAL ACTION HERE */
foo = operation_descr(&fimg, imgdesc, op, tick);
if (foo) {
	fprintf(stderr, "%s: real op -> %d\n", __func__, foo);
	abort();
	}

if (666 == tick) {
	;	/* plot the histogram ? */
	}

ecriture_sourcename(imgdesc, srcname);

foo = Image_TGA_save(dstname, imgdesc, 0);
if (foo) {
	fprintf(stderr, "tga save -> %d\n", foo);	
	return -1;
	}

Image_DeAllocate(imgdesc);	free(imgdesc);
fimg_destroy(&fimg);

return 0;
}
/* ------------------------------------------------------------------------ */
